const defaultPredicate = value => value !== null && value !== undefined;

const compact = (input, filterPredicate = defaultPredicate) => {
  if (Array.isArray(input) || typeof input !== 'object') return input;

  return Object.keys(input).reduce(
    (obj, key) =>
      (filterPredicate(input[key])
        ? Object.assign(obj, { [key]: compact(input[key]) })
        : obj),
    {},
  );
};

exports.default = compact;
module.exports = exports.default;
